package com.nisum.offertransactionservice.config;

import feign.Response;
import feign.RetryableException;
import feign.codec.ErrorDecoder;
import org.springframework.http.HttpStatus;

import java.util.Date;
import java.util.Objects;

public class CustomErrorDecoder implements ErrorDecoder {

    private final ErrorDecoder defaultErrorDecoder = new Default();

    @Override
    public Exception decode(String methodKey, Response response) {
        Exception exception = defaultErrorDecoder.decode(methodKey, response);

        if( Objects.equals(response.status(),HttpStatus.REQUEST_TIMEOUT.value())){
            return new RetryableException(HttpStatus.REQUEST_TIMEOUT.value(),"408 error", response.request().httpMethod(), new Date(),response.request());
        }
        return exception;
    }
}

